function [uindex]=get_uindex(varargin)
% function [uindex]=get_uindex(varargin)
% The fuction take the cell arrays of representing uncertainty, ie. Xpnummt,
% Xpdenmt, Xpdeadmt that appear in the same process edit window ; to specify the set 
% uncertain parameters, x(1) ,x(2) , ... to be be bounded in the process edit window.
[n]=length(varargin);
[a,b,c,d]=size(varargin{1});
uindex=cell(a,b,d);
for m=1:d
for h=1:a
   for k=1:b
		data=[];
      for i=1:n
         for l=1:c
            temp=imag(varargin{i}{h,k,l,m});
            data=[data ; temp(:)];
         end
		end
		data=sort(data);
		for j=1:length(data)
   		if data(j) > 0 
      		if isempty(uindex{h,k,m}) | ~any(data(j)==uindex{h,k,m})
         		uindex{h,k,m}=[uindex{h,k,m} data(j)];
      		end
   		end
      end
   end
end
end
