current_obj=gcbo;
IMENU=get(gcbo,'UserData');
switch IMENU
case 2100 % process
if n_of_TF>1
   edit_process;
else
   [f]=crfig(50,50,520,370,['Process ',num2str(p_index),' : (' num2str(row) ',' num2str(col) ')'],...
      'w','none','off');
set(f,'UserData',{[row col p_index],current_obj});
uicontrol(f,...
 'Style','text',...
 'Position',[20 300 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String',...
 'Process (edit)  =  --------------------------------------------------------------------------------');
uicontrol(f,...
 'Style','text',...
 'Position',[20 180 500 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String',...
 'Current process : --------------------------------------------------------------------------------------------');
uindex=get_uindex(Xpnummt,Xpdenmt,Xpdeadmt);
uicontrol(f,...
 'Style','text',...
 'Position',[125 125 260 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Center',...
 'String',['Only x [  ' num2str(uindex{row,col,p_index}) '  ] required']);
uicontrol(f,'Style','edit',...
 'Position',[100 195 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xpnum{row,col,1,p_index});
uicontrol(f,'Style','edit',...
 'Position',[100 165 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xpden{row,col,1,p_index});
uicontrol(f,'Style','edit',...
 'Position',[415 180 100 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String',Xpdead{row,col,1,p_index});
uicontrol(f,...
 'Style','frame',...
 'Position',[100 320 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
  'Style','edit',...
  'Position',[105 323 286 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',Xpnums{row,col,1,p_index},...
  'UserData',[14],...
  'Callback',['TF_index=1;cbackM;']);
uicontrol(f,...
 'Style','frame',...
 'Position',[100 275 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
  'Style','edit',...
  'Position',[105 278 286 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',Xpdens{row,col,1,p_index},...
  'UserData',[12],...
  'Callback',['TF_index=1;cbackM']);  
uicontrol(f,...
 'Style','frame',...
 'Position',[420 298 80 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
  'Style','edit',...
  'Position',[425 301 70 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',Xpdeads{row,col,1,p_index},...
  'UserData',[10],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[100 20 80 25],...
  'String','OK',...
  'UserData',[9],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[220 20 80 25],...
  'String',' Cancel',...
  'Callback','close');
uicontrol(f,...
 'Style','push',...
 'Position',[340 20 80 25],...
 'String','Help',...
 'Callback','sayhelp(2100)');
uicontrol(f,...
 'Style','text',...
 'Position',[20 105 90 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Upper limits of x:');
uicontrol(f,...
 'Style','text',...
 'Position',[20 67 90 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Lower limits of x:');
uicontrol(f,...
 'Style','frame',...
 'Position',[125 102 270 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
if all(length(vub)>=uindex{row,col,p_index})
   temp=num2str(vub(uindex{row,col,p_index}));
else
   temp='';
end
uicontrol(f,...
 'Style','edit',...
 'Position',[130 105 260 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'UserData',[3],...
 'String',temp,...
 'Callback','TF_index=1;cbackM');
uicontrol(f,...
 'Style','frame',...
 'Position',[125 64 270 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
if all(length(vlb)>=uindex{row,col,p_index})
   temp=num2str(vlb(uindex{row,col,p_index}));
else
   temp='';
end
uicontrol(f,...
 'Style','edit',...
 'Position',[130 67 260 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'UserData',[1],...
 'String',temp,...
 'Callback','TF_index=1;cbackM');
end
case 2200 % model
if n_of_TF>1
   edit_model;
else
   [f]=crfig(50,50,520,300,['Model ',num2str(p_index),': (' num2str(row) ',' num2str(col) ')'],...
      'w','none','off');
set(f,'UserData',{[row col p_index],current_obj});
if maxrow==1 & maxcol==1 & degree_freedom==2 & ~(cascade & p_index==1)
uicontrol(f,...
 'Style','text',...
 'Position',[20 170 130 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Disturbance lag (edit):');
uicontrol(f,...
 'Style','frame',...
 'Position',[155 167 180 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[160 170 160 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',mds,...
 'UserData',[18],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','text',...
 'Position',[20 70 130 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Current Disturbance lag:');
uicontrol(f,...
 'Style','edit',...
 'Position',[160 70 160 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',mtx2str(Tcanc(2,:),2));
end
uicontrol(f,...
 'Style','text',...
 'Position',[20 230 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Model   (edit) =  --------------------------------------------------------------------------------');
uicontrol(f,...
 'Style','text',...
 'Position',[20 120 200 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Current model:');
uicontrol(f,...
 'Style','text',...
 'Position',[100 110 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','-------------------------------------------------------------------------------------');
uicontrol(f,'Style','edit',...
 'Position',[100 125 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xmnum{row,col,1,p_index});
uicontrol(f,'Style','edit',...
 'Position',[100 95 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Center',...
 'String',Xmden{row,col,1,p_index});
uicontrol(f,'Style','edit',...
 'Position',[415 110 100 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String',Xmdead{row,col,1,p_index});
uicontrol(f,...
 'Style','frame',...
 'Position',[100 250 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 253 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xmnums{row,col,1,p_index},...
 'UserData',[8],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[100 205 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 208 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xmdens{row,col,1,p_index},...
 'UserData',[6],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[420 228 80 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[425 231 70 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xmdeads{row,col,1,p_index},...
 'UserData',[4],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[100 20 80 25],...
  'String','OK',...
  'UserData',[3],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[220 20 80 25],...
  'String',' Cancel',...
  'Callback','close');
uicontrol(f,...
 'Style','push',...
 'Position',[340 20 80 25],...
 'String','Help',...
 'Callback','sayhelp(2710)'); 
end
case 2300 % Forward part controller
   if maxrow<=1 & maxcol<=1
 		[f]=crfig(50,50,520,300,'Forward Path Controller','w','none','off');
		set(f,'UserData',{[row col p_index],current_obj});
		uicontrol(f,...
		 'Style','text',...
		 'Position',[20 220 400 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
		 'String','Invert:    ------------------------------------------------------------------------------------- ');
		uicontrol(f,...
		 'Style','text',...
		 'Position',[20 115 200 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
		 'String','Current IMC controller:');
		uicontrol(f,...
		 'Style','text',...
		 'Position',[100 80 400 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
		 'String','---------------------------------------------------------------------------');
		uicontrol(f,...
		 'Style','text',...
		 'Position',[20 150 100 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
		 'String','Order of the filter:');
		uicontrol(f,...
		 'Style','text',...
		 'Position',[230 150 100 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
		 'String','Filter time constant:');
		uicontrol(f,...
		 'Style','frame',...
		 'Position',[330 147 70 24],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k');
		uicontrol(f,...
		 'Style','edit',...
		 'Position',[335 150 60 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',Epsilon{row,col}(1),...
 		 'UserData',[12],...
		 'Callback',['TF_index=1;cbackM']);
		uicontrol(f,'Style','edit',...
		 'Position',[100 95 296 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',qden{row,col},...
		 'Enable','off');
		temp=strrep(qdenc{row,col},'e',num2str(Epsilon{row,col}(1)));
		uicontrol(f,'Style','edit',...
		 'Position',[100 65 296 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',temp,...
		 'Enable','off');
		uicontrol(f,...
		 'Style','frame',...
		 'Position',[100 240 296 24],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k');
		uicontrol(f,...
		 'Style','edit',...
		 'Position',[105 243 286 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',qnums{row,col},...
 		 'UserData',[8],...
		  'Callback',['TF_index=1;cbackM']);
		uicontrol(f,...
		 'Style','frame',...
		 'Position',[100 195 296 24],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k');
		uicontrol(f,...
		 'Style','edit',...
		 'Position',[105 198 286 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',qdens{row,col},...
 		 'UserData',[6],...
		  'Callback',['TF_index=1;cbackM']);
		uicontrol(f,...
		 'Style','frame',...
		 'Position',[145 147 35 24],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k');
		uicontrol(f,...
		 'Style','edit',...
		 'Position',[150 150 25 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',num2str(order{row,col}),...
 		 'UserData',[4],...
		 'Callback',['TF_index=1;cbackM']);
		uicontrol(f,...
		  'Style','push',...
		  'Position',[100 20 80 25],...
		  'String','OK',...
 		 'UserData',[3],...
		  'Callback',['TF_index=1;cbackM']); 
		uicontrol(f,...
		  'Style','push',...
		  'Position',[220 20 80 25],...
		  'String',' Cancel',...
		  'Callback','close');
		uicontrol(f,...
		 'Style','push',...
		 'Position',[340 20 80 25],...
		 'String','Help',...
		 'Callback','sayhelp(2300)'); 
 else
    % MIMO forward part controller
       if any(iscellempty(Xmnummt)) | any(iscellempty(Xmdenmt))
          errordlg('The model was not properly assigned');
          return
       end
       if all(~iscellempty(q))
          temp=questdlg('The controller was assigned, would you like to re-invert the model?',...
             'Whoops!!','No');
          switch temp
          case 'Yes'
             [qnummt,qdenmt,qdeadmt,Gnum,dec_M,input_delay,n_dec,TR,TL]=decouple(...
                Xmnummt,Xmdenmt,Xmdeadmt,y);
             not_save_yet=1;
             set(main_fig,'Name',['Internal Model Control Tuning - [' datadir NAMEFILE '*]']);
             set(current_obj,'BackgroundColor',192/255*[1 1 1]);
          end
       else
          [qnummt,qdenmt,qdeadmt,Gnum,dec_M,input_delay,n_dec,TR,TL]=decouple(...
             Xmnummt,Xmdenmt,Xmdeadmt,y);
          not_save_yet=1;
          set(main_fig,'Name',['Internal Model Control Tuning - [' datadir NAMEFILE '*]']);
          set(current_obj,'BackgroundColor',192/255*[1 1 1]);
       end
      if isempty(n_dec) n_dec=maxcol; end

      [f]=crfig(50,50,450,340,'Forward Path Controller --> MSF controller',192/255*[1 1 1],'none','off');
 		set(f,'UserData',{[row col p_index],current_obj});
       set(f,'DeleteFcn','clear M_handle;');
		uicontrol(f,...
		 'Style','text',...
		 'Position',[20 215 170 23],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','A vector of required input-delays :');
		uicontrol(f,...
		 'Style','frame',...
		 'Position',[190 217 200 24],...
		 'Foregroundcolor','k');
		uicontrol(f,...
		 'Style','edit',...
		 'Position',[195 220 190 18],...
		 'Backgroundcolor','w',...
       'Foregroundcolor','k',...
       'Enable','off',...
		 'String',num2str(input_delay),...
 		 'UserData',[12],...
		 'Callback','');
		uicontrol(f,...
		 'Style','text',...
		 'Position',[20 185 170 23],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','The decoupling delay matrix (M+)');
		uicontrol(f,...
		 'Style','frame',...
		 'Position',[190 187 200 24],...
		 'Foregroundcolor','k');
		uicontrol(f,...
		 'Style','edit',...
		 'Position',[195 190 190 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
       'Enable','off',...
		 'String',num2str(dec_M),...
 		 'UserData',[12],...
		 'Callback','');
    temp1=zeros(maxrow,maxcol);
    for i=1:maxrow
       for j=1:maxcol
          temp1(i,j)=length(mt2poly(qdenmt{i,j},y))-length(mt2poly(qnummt{i,j},y));
          qnum{i,j}=mtx2str(qnummt{i,j},2);
          if isempty(qnum{i,j})
             qnum{i,j}='0';
          end
          qnums{i,j}=num2str(qnummt{i,j});
          qden{i,j}=mtx2str(qdenmt{i,j},2);
          qdens{i,j}=num2str(qdenmt{i,j});
          qdead{i,j}=mtx2str(qdeadmt{i,j},4);
          qdeads{i,j,1,1}=num2str(qdeadmt{i,j});
          if isempty(qden{i,j}) | (length(qdenmt{i,j})==1 & ...
                mt2poly(qdenmt{i,j},y)==1)
            if isempty(qdead{i,j})
               q{i,j,1}=qnum{i,j};
            else
               q{i,j,1}=[qnum{i,j} '*' qdead{i,j}];
            end
         else
            temp=['(' qden{i,j} ')'];
            if isempty(qdead{i,j})
               q{i,j,1}=[qnum{i,j} '/' temp];
            else
               q{i,j,1}=[qnum{i,j} '/' temp '*' qdead{i,j}];
            end
         end
      end
   end
   order=max(temp1);
	uicontrol(f,...
		 'Style','text',...
		 'Position',[20 75 180 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','The part of model to be inverted (M-)');
  M_handle=Xuiarray([235 65 110 50],maxrow,maxcol,0,0,...
       'push','p_index=1;imcmenuM;','',q,3200,f);
	uicontrol(f,...
		 'Style','text',...
		 'Position',[20 155 170 23],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','Order of the diagonal filter :');
	uicontrol(f,...
		 'Style','frame',...
		 'Position',[190 157 200 24],...
		 'Foregroundcolor','k');

	order_handle=uicontrol(f,...
		 'Style','edit',...
		 'Position',[195 160 190 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',num2str(order),...
 		 'UserData',[12],...
		 'Callback','');
	uicontrol(f,...
		 'Style','text',...
		 'Position',[20 125 170 23],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','Diagonal filter time constants :');
	uicontrol(f,...
		 'Style','frame',...
		 'Position',[190 127 200 24],...
		 'Foregroundcolor','k');
    if length(Epsilon{1}) < maxcol
       Epsilon{1}(2:maxcol)=Epsilon{1}(1);
    end
    E_handle=uicontrol(f,...
		 'Style','edit',...
		 'Position',[195 130 190 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',num2str(Epsilon{1}),...
 		 'UserData',[12],...
		 'Callback','Epsilon{1}=str2num(get(gco,''String''));');
    uicontrol(f,...
		  'Style','push',...
		  'Position',[40 20 100 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		  'String','Nyquist Test',...
        'Callback',['[n_circle]=detect_RHPZ(qnummt(1:n_dec,1:n_dec),',...
           'qdenmt(1:n_dec,1:n_dec),qdeadmt(1:n_dec,1:n_dec),1);']); 
		uicontrol(f,...
		  'Style','push',...
		  'Position',[180 20 80 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		  'String','Done',...
 		 'UserData',[3],...
		  'Callback','cbackM;'); 
		uicontrol(f,...
		  'Style','push',...
		  'Position',[300 20 80 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		  'String',' Cancel',...
		  'Callback','close');
    
   end
   
case 3200 % Part of model to be inverted for the MIMO system
[f]=crfig(50,50,520,300,['Part of model to be inverted (',num2str(row),',',...
   num2str(col),')'],'w','none','off');
set(f,'UserData',{[row col p_index],current_obj});
uicontrol(f,...
 'Style','text',...
 'Position',[20 230 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Model   (edit) =  --------------------------------------------------------------------------------');
uicontrol(f,...
 'Style','text',...
 'Position',[20 120 200 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Current model:');
uicontrol(f,...
 'Style','text',...
 'Position',[100 110 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','-------------------------------------------------------------------------------------');
uicontrol(f,'Style','edit',...
 'Position',[100 125 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qnum{row,col,1,1});
uicontrol(f,'Style','edit',...
 'Position',[100 95 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Center',...
 'String',qden{row,col,1,1});
uicontrol(f,'Style','edit',...
 'Position',[415 110 100 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'Enable','off',...
 'HorizontalAlignment','Left',...
 'String',qdead{row,col,1,1});
uicontrol(f,...
 'Style','frame',...
 'Position',[100 250 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 253 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qnums{row,col,1,1},...
 'UserData',[8],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[100 205 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 208 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qdens{row,col,1,1},...
 'UserData',[6],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[420 228 80 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[425 231 70 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qdeads{row,col,1,1},...
 'Enable','off');
uicontrol(f,...
  'Style','push',...
  'Position',[100 20 80 25],...
  'String','OK',...
  'UserData',[3],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[220 20 80 25],...
  'String',' Cancel',...
  'Callback','close');

case 3210 
   if row~=col
      return
   end
[f]=crfig(50,50,460,300,['model of Pd lag (',num2str(row),',',...
   num2str(col),')'],'w','none','off');
set(f,'UserData',{[row col p_index],current_obj});
uicontrol(f,...
 'Style','text',...
 'Position',[20 230 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Pd*   (edit) =  --------------------------------------------------------------------------------');
uicontrol(f,...
 'Style','text',...
 'Position',[20 120 200 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Current Pd* :');
uicontrol(f,...
 'Style','text',...
 'Position',[100 110 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','-------------------------------------------------------------------------------------');
uicontrol(f,'Style','edit',...
 'Position',[100 125 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String','1');
uicontrol(f,'Style','edit',...
 'Position',[100 95 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Center',...
 'String',mtx2str(pd_prime{row,col,1,1},2));
uicontrol(f,...
 'Style','frame',...
 'Position',[100 250 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 253 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String','1',...
 'UserData',[8],...
 'Callback','');
uicontrol(f,...
 'Style','frame',...
 'Position',[100 205 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 208 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',num2str(pd_prime{row,col,1,1}),...
 'UserData',[6],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[100 20 80 25],...
  'String','OK',...
  'UserData',[3],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[220 20 80 25],...
  'String',' Cancel',...
  'Callback','close');
 
case 3220
    for i=1:maxcol
       temp=mq_gen(1,1,dec_M(i),1,1,order(i),y);
       [qd{i,i},qdnum{i,i},qdden{i,i}]=qd_mat(pd_prime{i,i},temp,Epsilon{2}(i),order(i),y);
       temp=strrep(qd{i,i},'e',num2str(Epsilon{2}(i)));
       qd{i,i}=strrep(qd{i,i},'e',['e(' num2str(i) ')']);
       set(QD_handle(maxcol*(i-1)+i),'tooltipstring',temp);
    end
   view_MIMO_qd;
   
case 2500 % Feedback part controller
if maxrow<=1 & maxcol<=1
[f]=crfig(50,50,520,300,'Feedback Path Controller','w','none','off');
set(f,'UserData',{[row col p_index],current_obj});
uicontrol(f,...
 'Style','text',...
 'Position',[20 250 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Invert (edit)  :    ------------------------------------------------------------------------------------- ');
uicontrol(f,...
 'Style','text',...
 'Position',[25 50 200 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','(Feedback path controller = q*qd )');
uicontrol(f,...
 'Style','text',...
 'Position',[50 85 200 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','q  = ');
uicontrol(f,...
 'Style','text',...
 'Position',[105 85 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','---------------------------------------------------------------------------');
uicontrol(f,...
 'Style','text',...
 'Position',[20 190 130 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Order of the filter:');
uicontrol(f,...
 'Style','text',...
 'Position',[230 190 100 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Filter time constant:');
uicontrol(f,...
 'Style','frame',...
 'Position',[330 187 70 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
if length(Epsilon{row,col})==1
   Epsilon{row,col}=[Epsilon{row,col} Epsilon{row,col}];
end
uicontrol(f,...
 'Style','edit',...
 'Position',[335 190 60 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',num2str(Epsilon{row,col}(2)),...
 'UserData',[16],...
 'Callback','TF_index=1;cbackM');
uicontrol(f,...
 'Style','text',...
 'Position',[20 160 50 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','qd-part:');
uicontrol(f,...
 'Style','Popup',...
 'String','Zero-pole cancelation from (1-mqqd)pd|Set to be 1|User defined in qd_mat.m',...  
 'Position',[100 160 210 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'UserData',[14],...
 'Callback','TF_index=1;cbackM');
uicontrol(f,...
 'Style','text',...
 'Position',[45 130 50 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','qd  = ');
if degree_freedom==1
   qd='1';
else
   if cascade
      if n_of_TF>1
         [mq]=mq_gen(Xmnummt(1,1,:,2),Xmdenmt(1,1,:,2),Xmdeadmt(1,1,:,2),...
            qfnummt{1},qfdenmt{1},F_order{1},y);
      else
         [mq]=mq_gen(Xmnummt{1,1,1,2},Xmdenmt{1,1,1,2},Xmdeadmt{1,1,1,2},...
            qfnummt{1},qfdenmt{1},F_order{1},y);
      end
      [qd{row,col},qdnum{row,col},qdden{row,col}]=qd_mat(Tcanc(2,:),...
         mq,Epsilon{row,col}(2),F_order{1},y);
   else
      if n_of_TF>1
         [mq]=mq_gen(Xmnummt,Xmdenmt,Xmdeadmt,qfnummt{1},...
            qfdenmt{1},F_order{1},y);
      else
         [mq]=mq_gen(Xmnummt{1,1},Xmdenmt{1,1},Xmdeadmt{1,1},qfnummt{1},...
            qfdenmt{1},F_order{1},y);
      end
      [qd{row,col},qdnum{row,col},qdden{row,col}]=qd_mat(Tcanc(2,:),...
         mq,Epsilon{row,col}(2),F_order{1},y);
   end
end
temp=strrep(qd{row,col},'e',num2str(Epsilon{row,col}(2)));
%[12]
uicontrol(f,'Style','edit',...
 'Position',[100 133 296 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',temp);
%[11]
uicontrol(f,'Style','edit',...
 'Position',[100 100 296 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qfden{row,col});
temp=strrep(qfdenc{row,col},'e',num2str(Epsilon{row,col}(2)));
%[10]
uicontrol(f,'Style','edit',...
 'Position',[100 70 296 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',temp);
uicontrol(f,...
 'Style','frame',...
 'Position',[100 270 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 273 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qfnums{row,col},...
 'UserData',[8],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[100 225 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[105 228 286 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',qfdens{row,col},...
 'UserData',[6],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[155 187 35 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
 'Style','edit',...
 'Position',[160 190 25 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',num2str(F_order{row,col}),...
 'UserData',[4],...
 'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[100 20 80 25],...
  'String','OK',...
 'UserData',[3],...
  'Callback',['TF_index=1;cbackM']); 
uicontrol(f,...
  'Style','push',...
  'Position',[220 20 80 25],...
  'String',' Cancel',...
  'Callback','close');
uicontrol(f,...
 'Style','push',...
 'Position',[340 20 80 25],...
 'String','Help',...
 'Callback','sayhelp(2300)'); 

else % MIMO Feedback part Controller
   if  any(iscellempty(diag(Xpddenmt)))
      errordlg('Give at least all diagonal elements of the Pd lag');
      return
   elseif any(iscellempty(q))
      errordlg('Forward part controller must be input first !');
      return
   else
       if any(iscellempty(diag(pd_prime)))
          if d_through_p
             [pd_prime,pd_prime_str,pdxs]=pdmodel(Xpnummt,Xpdenmt,vlb);
          else
             [pd_prime,pd_prime_str,pdxs]=pdmodel(Xpdnummt,Xpddenmt,vlb);
          end
          qfnummt=qnummt; qfdenmt=qdenmt; qfdeadmt=qdeadmt;qf=q;
       else
          temp=questdlg('The model of Pd was assigned, would you like to re-compute it?',...
             'Whoops!!');
          switch temp
          case 'Yes'
             if d_through_p
                [pd_prime,pd_prime_str,pdxs]=pdmodel(Xpnummt,Xpdenmt,vlb);
             else
                [pd_prime,pd_prime_str,pdxs]=pdmodel(Xpdnummt,Xpddenmt,vlb);
             end
	          qfnummt=qnummt; qfdenmt=qdenmt; qfdeadmt=qdeadmt;qf=q;
          case 'Cancel'
              return
          end
       end
      [f]=crfig(50,50,450,340,'Feedback Path Controller',192/255*[1 1 1],'none','off');
 		set(f,'UserData',{[row col p_index],current_obj});
       set(f,'DeleteFcn','clear QD_handle PD_handle;');
       uicontrol(f,...
		 'Style','text',...
		 'Position',[20 240 400 80],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String',['The current version of IMCTUNE assumes that the feedback part controller ',...
          'inverts the same part of the model as the forward part controller. However, ',...
          'it would have different set of filter time constants. In addition, the user ',...
          'can provide the model of the disturbance lag, Pd*,  as a diagonal matrix. ',...
          'The default diagonal elements of the Pd* are the fastest element ',...
          '(smallest time constant) in each row of Pd.']);
    uicontrol(f,...
		 'Style','text',...
		 'Position',[20 200 190 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','The model of the disturbance lag, Pd* :');
  PD_handle=Xuiarray([220 190 140 50],maxrow,maxcol,0,0,...
       'push','p_index=1;imcmenuM;','',pd_prime_str,3210,f);
	uicontrol(f,...
		 'Style','text',...
		 'Position',[20 75 190 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','The qd part of the feedback controller :');
    % Calculate qd
    if length(Epsilon)==1
       Epsilon(2)=Epsilon(1);
    end
    if length(Epsilon{2}) < maxcol
       Epsilon{2}(2:maxcol)=Epsilon{2}(1);
    end
    qdtemp=cell(maxrow,maxcol);
    for i=1:maxcol
       temp=mq_gen(1,1,dec_M(i),1,1,order(i),y);
       [qd{i,i},qdnum{i,i},qdden{i,i}]=qd_mat(pd_prime{i,i},temp,Epsilon{2}(i),order(i),y);
       qdtemp{i,i}=strrep(qd{i,i},'e',num2str(Epsilon{2}(i)));
       qd{i,i}=strrep(qd{i,i},'e',['e(' num2str(i) ')']);
    end
   QD_handle=Xuiarray([220 65 140 50],maxrow,maxcol,0,0,...
      'push','p_index=1;imcmenuM;','',qdtemp,3220,f);
   clear qdtemp
	uicontrol(f,...
		 'Style','text',...
		 'Position',[20 155 170 23],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','Order of the diagonal filter :');
	uicontrol(f,...
		 'Style','frame',...
		 'Position',[190 157 200 24],...
		 'Foregroundcolor','k');
	order_handle=uicontrol(f,...
		 'Style','edit',...
		 'Position',[195 160 190 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',num2str(order),...
 		 'UserData',[12],...
		 'Callback','');
	uicontrol(f,...
		 'Style','text',...
		 'Position',[20 125 170 23],...
		 'Backgroundcolor',192/255*[1 1 1],...
		 'Foregroundcolor','k',...
		 'HorizontalAlignment','Left',...
       'String','Diagonal filter time constants :');
	uicontrol(f,...
		 'Style','frame',...
		 'Position',[190 127 200 24],...
		 'Foregroundcolor','k');
    E_handle=uicontrol(f,...
		 'Style','edit',...
		 'Position',[195 130 190 18],...
		 'Backgroundcolor','w',...
		 'Foregroundcolor','k',...
		 'String',num2str(Epsilon{2}),...
 		 'UserData',[12],...
		 'Callback','Epsilon{2}=str2num(get(gco,''String''));');
		uicontrol(f,...
		  'Style','push',...
		  'Position',[150 20 80 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		  'String','Done',...
 		 'UserData',[3],...
		  'Callback','cbackM;'); 
		uicontrol(f,...
		  'Style','push',...
		  'Position',[270 20 80 25],...
		 'Backgroundcolor',192/255*[1 1 1],...
		  'String',' Cancel',...
		  'Callback','close');
   end
end



case 2400 % Pd
   %   not_save_yet=1;
[f]=crfig(50,50,500,370,['Pd : (' num2str(row) ',' num2str(col) ')'],'w','none','off');
set(f,'UserData',{[row col p_index],current_obj});
uicontrol(f,...
 'Style','text',...
 'Position',[20 300 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Pd (edit)  =  --------------------------------------------------------------------------------');
uicontrol(f,...
 'Style','text',...
 'Position',[20 190 200 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Current Pd:');
uicontrol(f,...
 'Style','text',...
 'Position',[100 180 400 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','--------------------------------------------------------------------------------------------');
pduindex=get_uindex(Xpdnummt,Xpddenmt);
uicontrol(f,...
 'Style','text',...
 'Position',[125 125 260 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Center',...
 'String',['Only x [  ' num2str(pduindex{row,col}) '  ] required']);
uicontrol(f,'Style','edit',...
 'Position',[100 195 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xpdnum{row,col});
uicontrol(f,'Style','edit',...
 'Position',[100 165 296 20],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',Xpdden{row,col});
uicontrol(f,...
 'Style','frame',...
 'Position',[100 320 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
  'Style','edit',...
  'Position',[105 323 286 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',Xpdnums{row,col},...
  'UserData',[12],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
 'Style','frame',...
 'Position',[100 275 296 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
uicontrol(f,...
  'Style','edit',...
  'Position',[105 278 286 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',Xpddens{row,col},...
  'UserData',[10],...
  'Callback',['TF_index=1;cbackM']);  
uicontrol(f,...
  'Style','push',...
  'Position',[100 20 80 25],...
  'String','OK',...
  'UserData',[9],...
  'Callback',['TF_index=1;cbackM']);
uicontrol(f,...
  'Style','push',...
  'Position',[220 20 80 25],...
  'String',' Cancel',...
  'Callback','close');
uicontrol(f,...
 'Style','push',...
 'Position',[340 20 80 25],...
 'String','Help',...
 'Callback','sayhelp(2100)');
uicontrol(f,...
 'Style','text',...
 'Position',[20 105 90 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Upper limits of x:');
uicontrol(f,...
 'Style','text',...
 'Position',[20 67 90 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'HorizontalAlignment','Left',...
 'String','Lower limits of x:');
uicontrol(f,...
 'Style','frame',...
 'Position',[125 102 270 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
if all(length(vub)>=pduindex{row,col})
   temp=num2str(vub(pduindex{row,col}));
else
   temp='';
end
uicontrol(f,...
 'Style','edit',...
 'Position',[130 105 260 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',temp,...
 'UserData',[3],...
 'Callback','TF_index=1;cbackM');
uicontrol(f,...
 'Style','frame',...
 'Position',[125 64 270 24],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k');
if all(length(vlb)>=pduindex{row,col})
   temp=num2str(vlb(pduindex{row,col}));
else
   temp='';
end
uicontrol(f,...
 'Style','edit',...
 'Position',[130 67 260 18],...
 'Backgroundcolor','w',...
 'Foregroundcolor','k',...
 'String',temp,...
 'UserData',[1],...
 'Callback','TF_index=1;cbackM');

case 4700
   temp=round(64/maxrow/maxcol)-1;
   temp1=(maxcol*(row-1)+col)*temp;
   temp=get(current_obj,'Backgroundcolor');
   if all(temp==[1 1 1])
      set(current_obj,'Backgroundcolor',COLOR_MAP(temp1,:));
   else
      set(current_obj,'Backgroundcolor',[1 1 1]);
   end
   
end
