% Variables to be saved as a particular problem
%-------------------------------------------------------------
global Xwc_ub_w Xwc_lb_w Priority

maxcol=1; maxrow=1; 					% maximum input and maximun output
degree_freedom=1;
not_save_yet=0;
Priority={'',''};

Epsilon={0.0001};Acc=0.005;Na=20;Mp=[1.05 1.05]; Mp2=[ 0.1 0.1];
decade=[-1 1]; numpdec=10; fun=''; cascade=0;
p_umax=0; m_umax=0; n_of_TF=1;d_through_p=0;

p={''}; p_unstable=0;
vub=[]; vlb=[]; x=[]; xns='';% process uncertainty parameters and bound
Xpnums={'Numerator'}; Xpdens={'Denominator'}; Xpdeads={'Deadtime'};
Xunidn={[0]}; Xunidd={[0]}; Xuniddt={[0]}; uindex={[]};
Xpnummt={[]};Xpdenmt={[]};Xpdeadmt={[]};
Xpnum={''};Xpden={''};Xpdead={''};

pd={'1'};  pds='1'; pdxs=pds;
Xpdnums={'1'};
Xpddens={'1'};
Xpdnummt={[1]}; Xpddenmt={[1]};
Xpdnum={'1'}; Xpdden={'1'};
Xpdunidn={[0]}; Xpdunidd={[0]}; pduindex={[]};

m={''}; y=[]; % model parameter, it has the same bound as the process parameter
Xmnums={'Numerator'}; Xmdens={'Denominator'}; Xmdeads={'Deadtime'};
Xmnummt={[]};Xmdenmt={[]};Xmdeadmt={[]}; muindex={[]};
Xmunidn={[0]};Xmunidd={[0]};Xmuniddt={[0]};
Xmnum={''};Xmden={''};Xmdead={''};
Tcanc=[0 0 0 0 1;0 0 0 0 1];
mds='0 0 0 0 1';
pd_prime={[1]};

q={''}; qs={''}; qfs={''};% controller string variable , could be uncertain by uncertain model
qf={''};  qdenc={''}; qfdenc={''};
qd={'1'}; qdnum={[1]}; qdden={[1]};
qnummt={[]};qfnummt={[]};
qdenmt={[]};qfdenmt={[]};
qdeadmt={[]};qfdeadmt={[]};
qnums={'Numerator'}; qdens={'Denominator'}; qdeads={'Deadtime'};
qfnums={'Numerator'}; qfdens={'Denominator'}; qfdeads={'Deadtime'};
qnum={''};qden={''};qdead={''}; 
qfnum={''};qfden={''};qfdead={''};

F_order={[0]};order={[0]};%P_plus=[];
%mplus_dts='';mplus_dt=[];

Satub=10000*ones(1,maxcol);
Satlb=-Satub;
satubs=num2str(Satub);
satlbs=num2str(Satlb);

Ds={[1]}; Ks={[]}; K=Ks; Ksp=[]; input_delay=[0]; dec_M=[0]; % decoupling matrix
Dstr={''};  Kstr={''}; Kspstr={''}; Xwc_ub_w={[]}; Xwc_lb_w={[]};
% Kp=[];Ki=[];Kd=[]; Nstr={''};
Gnum={}; TR=[]; TL=[]; n_dec=[]; mq={};

% Other variables, graphical and numerical results
%-------------------------------------------------------------

refreq=[10^decade(1) 10^decade(2)];
upb=[];
lwb=[];

% Variables to save for single loop system
%-------------------------------------------------------------
Varsave=' Epsilon Acc Na Mp Mp2 decade numpdec fun Tcanc ';
Varsave=[Varsave 'vub vlb p_umax m_umax mds satubs satlbs xns '];
Varsave=[Varsave 'degree_freedom cascade d_through_p '];
Varsave=[Varsave 'p x Xpnums Xpdens Xpdeads '];
Varsave=[Varsave 'm y Xmnums Xmdens Xmdeads '];
Varsave=[Varsave 'pd Xpdnums Xpddens qdeadmt '];
Varsave=[Varsave 'q qnums qdens qnummt qdenmt qnum qden order qdenc qs '];

% Variables to save for 2df and cascade system
%-------------------------------------------------------------
Var2save=[Varsave 'qf qfnums qfdens qfnummt qfdenmt qfnum qfden F_order qfdenc qfs '];
Var2save=[Var2save 'qd qdnum qdden mq '];

% Variable to save for MIMO system
Var3save=[Var2save 'input_delay dec_M Ds Dstr qdeadmt K Kstr Ksp Kspstr '];
Var3save=[Var3save 'Xwc_ub_w Xwc_lb_w qd qdnum qdden pd_prime Priority '];
Var3save=[Var3save 'Gnum TR TL n_dec pdxs '];

