function [Xwc_ub_w,Xwc_lb_w]=reset_ublb(decade,numpdec,vub,maxrow,maxcol)
% This function reset the upper and lower bound table to
% assure the correct dimension and initialvalues.

global Xwc_ub_w Xwc_lb_w

npoints=round((decade(2)-decade(1))*numpdec);
refreq=[10^decade(1) 10^decade(2)];
freq=logspace(decade(1),decade(2),npoints);
freq_ln=length(freq);

for i=1:maxrow
   for j=1:maxcol
      Xwc_ub_w{i,j}=[zeros(freq_ln,1) freq' zeros(freq_ln,length(vub))];
      Xwc_lb_w{i,j}=[ones(freq_ln,1) freq' zeros(freq_ln,length(vub))];
   end
end


            
            
            
      