function [A]=sw_col(A,T)
% function [A]=sw_col(A,T)
% transforms a cell array or matrix A by
% column switching using transformation matrix T.
% This function was designed to work with function transform.m
% and MSFgainM.m
   [m,n]=size(T);
   sorx=A;
   for i=1:n
      temp=find(T(i,:)==1);
      sorx(:,i)=A(:,temp);
   end
   A=sorx;
   